export declare function reverse<T>(list: T[]): T[];
export declare function sum<T>(list: number[]): number;
export declare function iter<T>(iterable: {
    length: number;
    [i: number]: T;
}): T[];
export declare function flatten<T>(input: T[][]): T[];
type Selector<T, U> = (v: T) => U;
export declare function distinct<T, U = null>(input: T[], selector?: Selector<T, U extends null ? T : U>): (U extends null ? T : U)[];
export declare function betweenIncl(test: number, boundA: number, boundB: number): boolean;
export declare function intersection<T>(a: T[], b: T[]): T[];
export declare function selectMany<T, U>(input: T[], selector: Selector<T, U[]>): U[];
export declare function range(a: number, b?: number | null): number[];
export declare function aggregate<T, K extends string>(list: T[], keySelector: (arg: T) => K, aggregate: (current: T, accumulator: number) => number): {
    [k: string]: number;
};
export declare function aggCount<T, K extends string>(list: T[], keySelector: (arg: T) => K): {
    [k: string]: number;
};
export declare function contains<T>(arr: T[], search: T): boolean;
interface GroupByResult<T> {
    [k: string]: T[];
    [k: number]: T[];
}
export declare function groupBy<T, K extends string | number>(list: T[], keySelector: (item: T) => K): GroupByResult<T>;
interface GroupByArrResult<T, K> {
    key: K;
    values: T[];
}
export declare function groupByArr<T, K>(list: T[], keySelector: (item: T) => K, compareKeyByReference?: boolean): GroupByArrResult<T, K>[];
export declare function orderByAscending<T>(list: T[], selector: (item: T) => number): void;
export declare function orderByDescending<T>(list: T[], selector: (item: T) => number): void;
export declare function orderByStrAscending<T>(list: T[], selector: (item: T) => string): void;
export declare function orderByStrDescending<T>(list: T[], selector: (item: T) => string): void;
export declare function last<T>(items: T[], selector: (item: T) => boolean): T | null;
export declare function first<T>(items: T[], selector: (item: T) => boolean): T | null;
export declare function min<T>(items: T[], selector: (item: T) => number): T;
export declare function any<T>(items: T[], selector: (item: T) => boolean): boolean;
export declare function all<T>(items: T[], selector: (item: T) => boolean): boolean;
export declare function max<T>(items: T[], selector: (item: T) => number): T;
export declare function splitNWays<T>(elements: T[], n: number): T[][];
export declare function overlapBetween<T>(a: T[], b: T[]): T[];
export declare function dedupe<T>(list: T[]): T[];
export declare function distinctByKey<T>(value: T[], keySelector: (value: T) => string): T[];
export declare function stringDiff(a: string, b: string): number;
export {};
