import { ErrResponse } from './Fetcher';
import React from 'react';
type DefaultLister<T> = T extends Array<any> ? {
    asList: T extends (infer U)[] ? U[] : never;
} : {
    asList: never;
};
export type AsyncResult<T> = {
    loading: boolean;
    error: string | null;
    reload: () => void;
    LoadingElement: JSX.Element | null;
    LoadingOrErrorElement: JSX.Element | null;
    NoResultElement: JSX.Element | null;
} & DefaultLister<T> & ({
    loadingOrError: true;
    result: T | null;
} | {
    loadingOrError: false;
    result: T;
});
type CallbackWithInput<T, I> = (input?: I) => Promise<T | ErrResponse>;
export declare function useAsync<T, I>(fx: CallbackWithInput<T, I>, options?: {
    withoutAuth: boolean;
    dependsOn?: any[];
}): AsyncResult<T> & {
    reload(input: I): void;
};
export declare function LoadingEl(loading: boolean, error: string | null, reload?: () => void): React.JSX.Element | null;
export interface AsyncAction<T, U> {
    loading: boolean;
    error: string | null;
    callback(input: U): void;
    result: T | null;
    LoadingElement: JSX.Element | null;
    NoResultElement: JSX.Element | null;
}
export declare function useAsyncAction<T, U = any>(callback: (arg: U) => Promise<T>, dependsOn: any[]): AsyncAction<T, U>;
export declare function NoResultEl(LoadingElement: JSX.Element | null, result: any): React.JSX.Element | null;
export declare function addDevelopmentDelay<T>(p: Promise<T>): Promise<T>;
export declare function sleep(ms: number): Promise<unknown>;
export {};
