"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatCents = formatCents;
exports.parseCents = parseCents;
function formatCents(n) {
    if (n === undefined)
        return '0.00';
    var isNeg = n < 0;
    if (isNeg)
        n = n * -1;
    n = Math.round(n);
    var neg = isNeg ? '-' : '';
    var dollars = Math.floor(n / 100);
    var cents = (n % 100).toString().padStart(2, '0');
    return "".concat(neg).concat(dollars.toLocaleString(), ".").concat(cents);
}
function parseCents(str) {
    var parts = str.replace(/[^0-9\-.]+/g, '').split('.');
    var dollars = parseInt(parts[0], 10);
    var cents = 0;
    if (parts.length >= 2) {
        cents = parseInt(parts[1].substring(0, 2).padEnd(2, '0'), 10);
    }
    if (dollars < 0 || str.startsWith("-")) {
        cents = -cents;
    }
    if (isNaN(dollars))
        dollars = 0;
    if (isNaN(cents))
        cents = 0;
    return Math.round(dollars * 100 + cents);
}
