type Callback<T> = (input: T) => void;
export type Subscription = {
    cancel: Callback<void>;
};
interface Listener<T> {
    callback: Callback<T>;
    removed: boolean;
}
export declare class EventEmitter<T> {
    listeners: Listener<T>[];
    lastValue?: T;
    debugName: string;
    static counter: number;
    constructor(debugName?: string);
    log(message: string, opts?: any): void;
    warn(message: string): void;
    subscribe(callback: Callback<T>): Subscription;
    subscribeAndFireLast(callback: Callback<T>): Subscription;
    emit(value: T): void;
    static reactValue<T>(emitter?: EventEmitter<T>): T | undefined;
}
export {};
