import React, { PropsWithChildren } from 'react';
type CancelFunc = () => void;
export declare const TFormContext: React.Context<{
    value: any;
    inputUpdated: (k: string, value: any) => void;
    triggerUpdate: (k: string, value: any) => void;
    subscribeToExternalChanges(k: string, callback: (value: any) => void): CancelFunc;
    subscribeToAllChanges(k: string, callback: (value: any) => void): CancelFunc;
    subscribeToChanges(k: string, callback: (value: any) => void, externalOnly?: boolean): CancelFunc;
    editing: boolean;
}>;
export type FormObj = {
    [k: string]: any;
};
export declare function TForm<T extends FormObj>(props: PropsWithChildren<{
    onSubmit: (value: T) => void;
    onChange?: (value: T) => void;
    value: T;
    editing: boolean;
}>): React.JSX.Element;
export {};
