"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TFormContext = void 0;
exports.TForm = TForm;
var react_1 = __importStar(require("react"));
var EventEmitter_1 = require("../EventEmitter");
exports.TFormContext = (0, react_1.createContext)({
    value: undefined,
    inputUpdated: function (k, value) {
        console.error('missing <TForm>');
    },
    triggerUpdate: function (k, value) {
        console.error('missing <TForm>');
    },
    subscribeToExternalChanges: function (k, callback) {
        return function () { };
    },
    subscribeToAllChanges: function (k, callback) {
        return function () { };
    },
    subscribeToChanges: function (k, callback, externalOnly) {
        if (externalOnly === void 0) { externalOnly = true; }
        // legacy
        return function () { };
    },
    editing: false,
});
var blankCallback = function () { };
function TForm(props) {
    var obj = (0, react_1.useRef)(props.value);
    // pass change events to targeted child elements
    var events = (0, react_1.useRef)(new EventEmitter_1.EventEmitter());
    // trigger refresh when props.value changes
    var _a = (0, react_1.useState)(props.value), refresh = _a[0], setRefresh = _a[1];
    (0, react_1.useEffect)(function () {
        obj.current = props.value;
        setRefresh(props.value);
        events.current.emit({ value: null, external: true });
    }, [props.value]);
    var onChangeRef = (0, react_1.useRef)(props.onChange || blankCallback);
    onChangeRef.current = props.onChange || blankCallback;
    var ctx = (0, react_1.useMemo)(function () { return ({
        value: obj.current,
        // the input responsible for this key triggered an update
        inputUpdated: function (key, newValue) {
            obj.current[key] = newValue;
            events.current.emit({
                external: false,
                key: key,
                value: newValue,
            });
            onChangeRef.current(obj.current);
        },
        // someone else triggered an update
        triggerUpdate: function (key, value) {
            obj.current[key] = value;
            events.current.emit({
                external: true,
                key: key,
                value: value,
            });
            onChangeRef.current(obj.current);
        },
        subscribeToExternalChanges: function (k, callback) {
            var sub = events.current.subscribe(function (input) {
                if (!input.external)
                    return;
                // global update
                if (input.key === undefined) {
                    callback(obj.current[k]);
                    return;
                }
                // scoped change to this input
                if (input.key === k) {
                    callback(obj.current[k]);
                }
            });
            return sub.cancel;
        },
        subscribeToChanges: function (k, callback, externalOnly) {
            if (externalOnly === void 0) { externalOnly = true; }
            var sub = events.current.subscribe(function (input) {
                if (externalOnly && !input.external)
                    return;
                // global update
                if (input.key === undefined) {
                    callback(obj.current[k]);
                    return;
                }
                // scoped change to this input
                if (input.key === k) {
                    callback(obj.current[k]);
                }
            });
            return sub.cancel;
        },
        subscribeToAllChanges: function (k, callback) {
            var sub = events.current.subscribe(function (input) {
                // global update
                if (input.key === undefined) {
                    callback(obj.current[k]);
                    return;
                }
                // scoped change to this input
                if (input.key === k) {
                    callback(obj.current[k]);
                }
            });
            return sub.cancel;
        },
        editing: props.editing,
    }); }, [props.editing, obj.current, refresh, props.onChange]);
    return (react_1.default.createElement(exports.TFormContext.Provider, { value: ctx },
        react_1.default.createElement("form", { onSubmit: function (e) {
                e.preventDefault();
                if (!obj) {
                    console.warn('missing .value');
                    return;
                }
                props.onSubmit(obj.current);
            } }, props.children)));
}
