"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TFormValue = TFormValue;
var react_1 = __importStar(require("react"));
var TForm_1 = require("./TForm");
var use_debounce_1 = require("use-debounce");
var material_1 = require("@mui/material");
var Wrapper = (0, material_1.styled)('div')(function (_a) {
    var marginBottom = _a.marginBottom, theme = _a.theme;
    return ({
        marginBottom: theme.spacing(2),
    });
});
function useDebounceHelper(value, debounce) {
    if (!debounce) {
        return value;
    }
    var db = (0, use_debounce_1.useDebounce)(value, debounce || 0)[0];
    return db;
}
function TFormValue(props) {
    var ctx = (0, react_1.useContext)(TForm_1.TFormContext);
    var _a = (0, react_1.useState)(), value = _a[0], setValue = _a[1];
    var debouncedValue = useDebounceHelper(value, props.debounce || 0);
    var calculatedValue = (value !== undefined ? value : ctx.value[props.objKey]) || '';
    (0, react_1.useEffect)(function () {
        return ctx.subscribeToExternalChanges(props.objKey, function (value) {
            setValue(value);
        });
    }, [ctx]);
    (0, react_1.useEffect)(function () {
        if (debouncedValue === undefined)
            return;
        ctx.inputUpdated(props.objKey, debouncedValue);
    }, [debouncedValue]);
    (0, react_1.useEffect)(function () {
        if (!props.onChange)
            return;
        if (debouncedValue === undefined)
            return;
        props.onChange(debouncedValue, {
            update: ctx.triggerUpdate,
        });
    }, [debouncedValue, props.onChange]);
    if (!ctx.editing) {
        return (react_1.default.createElement(Wrapper, { marginBottom: !props.noBottomMargin },
            props.label && react_1.default.createElement(material_1.Typography, { style: { fontSize: '0.7rem' } }, props.label),
            react_1.default.createElement(material_1.Typography, { variant: "body1" }, (props.displayValue ? props.displayValue(calculatedValue) : calculatedValue) || '-')));
    }
    return props.children({
        value: calculatedValue || '',
        onChange: setValue,
    });
}
