"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TTextField = TTextField;
var react_1 = __importDefault(require("react"));
var TFormValue_1 = require("./TFormValue");
var material_1 = require("@mui/material");
function autoFormat(raw, phone, email) {
    if (phone) {
        var nOnly = raw.replace(/[^0-9x]+/g, '');
        if (nOnly.length < 7) {
            return nOnly.substring(0, 3) + ' ' + nOnly.substring(3);
        }
        var value = '(' + nOnly.substring(0, 3) + ') ' + nOnly.substring(3, 6) + ' ' + nOnly.substr(6);
        return value.split('x').join(' x');
    }
    if (email) {
        return raw.toLowerCase();
    }
    return raw;
}
function TTextField(props) {
    var phone = props.phone, email = props.email;
    return (react_1.default.createElement(TFormValue_1.TFormValue, { label: props.label, obj: props.obj, objKey: props.objKey, debounce: 200, noBottomMargin: props.noBottomMargin }, function (p) { return (react_1.default.createElement(material_1.TextField, { label: props.label, type: props.password ? 'password' : 'text', variant: "outlined", placeholder: props.placeholder, InputLabelProps: { shrink: true }, onBlur: function (e) {
            var src = e.target.value;
            var formatted = autoFormat(src, phone, email);
            if (formatted !== src) {
                e.target.value = formatted;
                p.onChange(formatted);
            }
        }, style: {
            width: props.width,
            minWidth: props.width !== undefined ? '0' : 100,
        }, sx: {
            marginBottom: !props.noBottomMargin ? 2 : 0.5,
        }, required: props.required, disabled: props.disabled, fullWidth: true, value: p.value, onChange: function (e) { return p.onChange(e.target.value); } })); }));
}
