"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UAutoComplete = UAutoComplete;
var react_1 = __importStar(require("react"));
var use_debounce_1 = require("use-debounce");
var AsyncUtils2_1 = require("../AsyncUtils2");
var material_1 = require("@mui/material");
function newOption(value) {
    return {
        id: -1,
        name: value,
    };
}
function UAutoComplete(props) {
    var _a = (0, react_1.useState)(''), search = _a[0], setSearch = _a[1];
    var debounced = (0, use_debounce_1.useDebounce)(search, 500, { leading: true })[0];
    var fetcherSearchDeps = [debounced];
    if (props.fetcherDeps) {
        fetcherSearchDeps.push.apply(fetcherSearchDeps, props.fetcherDeps);
    }
    var fetcher = (0, AsyncUtils2_1.useAsync2)(function (opt) { return props.fetcher(opt); }, { search: debounced }, fetcherSearchDeps);
    var _b = (0, react_1.useState)(props.initialValue ||
        {
            id: -1,
            name: '',
        }), value = _b[0], setValue = _b[1];
    var valueRef = (0, react_1.useRef)(value);
    var searchRef = (0, react_1.useRef)('');
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(material_1.Autocomplete, { value: value, loading: fetcher.loading, defaultValue: props.initialValue, disabled: props.disabled, options: fetcher.asList, className: props.className, onBlur: function () {
                if (props.freeSolo && valueRef.current.name !== searchRef.current) {
                    var srcList = fetcher.asList.filter(function (l) { return l.name === search; });
                    if (srcList.length >= 1) {
                        setValue(srcList[0]);
                        props.onChange(srcList[0]);
                        return;
                    }
                    var v = newOption(search);
                    setValue(v);
                    props.onChange(v);
                }
                if (props.onCancel)
                    props.onCancel();
            }, onInputChange: function (event, newInputValue) {
                setSearch(newInputValue);
                searchRef.current = newInputValue;
            }, filterOptions: function (options, params) {
                var filtered = options.slice(0);
                // Suggest the creation of a new value
                if (props.freeSolo && params.inputValue !== '') {
                    filtered.push({
                        inputValue: params.inputValue,
                        id: -1,
                        name: "Add \"".concat(params.inputValue, "\""),
                    });
                }
                return filtered;
            }, selectOnFocus: true, onChange: function (e, newValue) {
                if (newValue === null || newValue === undefined)
                    return;
                if (typeof newValue === 'string') {
                    return;
                }
                searchRef.current = newValue.name;
                if (newValue.id === -1) {
                    var v = newOption(newValue.inputValue);
                    valueRef.current = v;
                    setValue(v);
                    props.onChange(v);
                    return;
                }
                valueRef.current = newValue;
                setValue(newValue);
                props.onChange(newValue);
            }, renderOption: function (props, opt) { return react_1.default.createElement(material_1.MenuItem, __assign({}, props), typeof opt === 'string' ? opt : opt.name); }, getOptionLabel: function (opt) { return (typeof opt === 'string' ? opt : opt.name); }, freeSolo: props.freeSolo, blurOnSelect: true, renderInput: function (params) {
                var InputProps = params.InputProps, inputProps = params.inputProps, InputLabelProps = params.InputLabelProps, others = __rest(params, ["InputProps", "inputProps", "InputLabelProps"]);
                return (react_1.default.createElement(material_1.TextField, __assign({}, others, { inputProps: Object.assign({}, inputProps, {
                        onKeyDown: props.onKeyDown,
                        onFocus: function (e) {
                            // @ts-ignore
                            inputProps.onFocus(e);
                            if (props.clearOnFocus === undefined || props.clearOnFocus === true) {
                                e.target.value = '';
                                // @ts-ignore
                                inputProps.onChange(e);
                            }
                        },
                    }), InputProps: Object.assign({}, InputProps, {
                        disableUnderline: true,
                    }), InputLabelProps: Object.assign({}, InputLabelProps, {
                        shrink: props.shrinkLabel,
                    }), autoFocus: props.autoFocus, required: props.required, label: props.label, variant: props.type || 'outlined' })));
            } }),
        props.noBottomPadding ? null : react_1.default.createElement("div", { style: { height: 16 } })));
}
